#ifndef __hogwash_h
#define __hogwash_h

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#define PID_FILE		"/var/run/hogwash.pid"
#define OUTPUT_FILE		"hogwash_io.txt"

#define MIN_SNAPLEN  	68
#define PROMISC			1
#define READ_TIMEOUT	500
/*ethernet*/
#define SNAPLEN			1514

/*libpcap includes*/
#include <pcap.h>
#include <pcap-namedb.h>
#include <net/bpf.h>
#include <libnet.h>
#include <pthread.h>


/*internet includes*/
#include <netinet/in.h>


#define BUFFSIZE	1600
#define NUMBUFFS	50
#define BUFFTIMEOUT	2

typedef struct interface_rec{
	/*libpcap*/
	int						num;
	char*					string;
	pcap_t*					pds;
	int						snaplen;
	int						mtu;
	int						datalink;
	
	/*libnet*/
	struct libnet_link_int*	network;
	u_char*					packet;
	int						max_packet;
	
	/*control*/
	pthread_t				thread;
}interface_rec;


struct sockaddr_ll{
	unsigned short  sll_family;    /* Always AF_PACKET */
    unsigned short  sll_protocol;  /* Physical layer protocol */
    int             sll_ifindex;   /* Interface number */
    unsigned short  sll_hatype;    /* Header type */
    unsigned char   sll_pkttype;   /* Packet type */
    unsigned char   sll_halen;     /* Length of address */
    unsigned char   sll_addr[8];   /* Physical layer address */
};



struct SaveRec{
	char			Buff[BUFFSIZE];
	struct timeval	timestamp;
	unsigned int 	len;
	struct SaveRec*	next;
};

#endif
