#include "snort.h"

#ifndef __SPP_HOST_ID_H_
#define __SPP_HOST_ID_H_


typedef struct _host_rec{
	struct in_addr		IP;
	unsigned short		host_type;
	struct timeval		last_time;
	
	struct _host_rec*	next;
} host_rec;

typedef struct _tree_node{
	struct _tree_node*	node[256];
	host_rec*			host;
} tree_node;

#define SIG_DF		1
#define SIG_SACKOK	2
#define SIG_NOP		4

typedef struct _sig_rec{
	unsigned long	WindowSize;
	unsigned char	TTL;
	unsigned int	MaxSegSize;
	char			WindowScaling;
	unsigned char	BitFlags;
	/*must come last*/
	unsigned short	ID;
} sig_rec;



void HostIDPreprocFunction(Packet* p);
void HostIDInit(u_char* args);
void SetupHostID(void);

host_rec*	node_head;
#endif
